/* Nome: 0000_GERFUNO_STRCOMP                                     */
/* Descrio:                                                     */
/* COMPARA DUAS STRINGS IGNORANDO O CASE (MAISCULAS, minsculas)
   E, OPCIONALMENTE, A EXISTNCIA DE ACENTOS E CEDILHA,
   DE ACORDO COM O 3 PARAM. DE ENTRADA:
   0 = IGNORA ACENTOS (DEFAULT)
   1 = CONSIDERA ACENTOS
   Sada:
   RETORNA 0 SE OS STRINGS FOREM IGUAIS E 1 SE DIFERENTES.        */

/* EXEMPLOS:
   STRCOMP('A', 'A')    = 0   (IGUAL)
   STRCOMP('A', '', 1) = 1   (DIFERENTE)
   STRCOMP('N', '')    = 0   (IGUAL)
   STRCOMP('  ', 'a  ') = 0 (IGUAL)                          
   STRCOMP('Cao Empanado', 'Cacao empanado') = 0 (IGUAL)
   STRCOMP('Almndegas de Peru', 'ALMONDEGAS DE PERU', 1) = 1 (DIFERENTE)
*/

/* Criao: Alexis
   Adaptao: Dmaso (28/10/2004)                                   */

CREATE OR REPLACE FUNCTION STRCOMP
(P_STRING1 IN VARCHAR2,
 P_STRING2 IN VARCHAR2,
 P_IDIGNORESYMBOLS IN NUMBER DEFAULT 0) RETURN NUMBER IS

 V_RESULT NUMBER;
 V_POSTIL NUMBER;
 OLD_TEXT VARCHAR2(255);
 NEW_TEXT VARCHAR2(255);

BEGIN
   V_RESULT := 0;

   OLD_TEXT := UPPER(P_STRING1);
   NEW_TEXT := UPPER(P_STRING2);

   IF P_IDIGNORESYMBOLS = 0 THEN
      /* TIRA OS ACENTOS DO PRIMEIRO STRING */
      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'C' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'Y' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(OLD_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         OLD_TEXT := SUBSTR(OLD_TEXT, 1, V_POSTIL - 1) || 'N' || SUBSTR(OLD_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(OLD_TEXT,'');
      END LOOP;

      /* TIRA OS ACENTOS DO SEGUNDO STRING */
      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'A' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'E' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'I' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'O' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'U' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'C' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'Y' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;

      V_POSTIL := INSTR(NEW_TEXT,'');
      WHILE (V_POSTIL > 0) LOOP
         NEW_TEXT := SUBSTR(NEW_TEXT, 1, V_POSTIL - 1) || 'N' || SUBSTR(NEW_TEXT, V_POSTIL + 1, 255);
         V_POSTIL := INSTR(NEW_TEXT,'');
      END LOOP;
   END IF;
   IF (UPPER(LTRIM(RTRIM(NEW_TEXT))) <> UPPER(LTRIM(RTRIM(OLD_TEXT)))) THEN
      V_RESULT := 1;
   END IF;
   RETURN(V_RESULT);
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('STRCOMP','4.05.103'); END;
/

