-- ========================================================================================================
-- VIEW: PROD_ENTR_REF  (BUSCA AS NOTAS DE ENTRADA POR PRODUTO E FILIAL, COMO REFERÊNCIA PARA BUSCAR A
-- ENTRADA CORRESPONDENTE A SAÍDA DE UM PRODUTO NA APURAÇÃO DE COMPLEMENTO E RESSARCIMENTO DO ICMS ST )
-- ========================================================================================================
CREATE OR REPLACE FORCE VIEW PROD_ENTR_REF (CHAVE, CDFILIAL, NRLANCTONF, NRSEQITPROD, CDPRODUTO, SGUNIDADE, QTITEMPROD, VRCONTITEM, VRBASEST,
                                            VRST, VRICMS, CDFILIRECE, CDMODDOCFISC, CDSERIEENTR, NRNOTAFISC, DTENTRSAID, CDARVPROD, NRACESSONFE)
AS
   SELECT NF.CDFILIAL||NF.NRLANCTONF AS CHAVE, NF.CDFILIAL, NF.NRLANCTONF, MAX(IP.NRSEQITPROD) AS NRSEQITPROD, PR.CDPRODUTO, PR.SGUNIDADE,
          SUM(ROUND(IP.QTITEMPROD*NVL(PN.VRFATOCONV,1),3)) AS QTITEMPROD, SUM(IP.VRCONTITEM) AS VRCONTITEM,
          SUM(NVL(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'80','B'),0)) AS VRBASEST,
          SUM(NVL(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'80','I'),0) + NVL(VRENCARGOIMPXML,0) +
              NVL(VALOR_FECP_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'80','I'),0)) AS VRST,
          SUM(NVL(VALOR_IMPOSTO_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'00','I','1'),0) +
              NVL(VALOR_FECP_ITEM_NFE(IP.CDFILIAL,IP.NRLANCTONF,IP.NRSEQITPROD,'00','I'),0)) AS VRICMS,
          NF.CDFILIRECE, NF.CDMODDOCFISC, NF.CDSERIEENTR, NF.NRNOTAFISC, NF.DTENTRSAID, PR.CDARVPROD, NF.NRACESSONFE
     FROM NOTAFISCAL NF,  ITEMPRODUTO IP, PRODUTO PR, PRODUTO PN
    WHERE NF.CDFILIAL   = IP.CDFILIAL
      AND NF.NRLANCTONF = IP.NRLANCTONF
      AND NF.IDENTRSAIDOP = 'E'
      AND IP.CDPRODUTO = PN.CDPRODUTO
      AND PN.CDPRODESTO = PR.CDPRODESTO
      AND PR.CDPRODUTO = PR.CDPRODESTO
    GROUP BY NF.CDFILIAL, NF.NRLANCTONF, PR.CDPRODUTO, PR.SGUNIDADE, NF.CDFILIRECE, NF.CDMODDOCFISC,
          NF.CDSERIEENTR, NF.NRNOTAFISC, NF.DTENTRSAID, PR.CDARVPROD, NF.NRACESSONFE
/

--VERSÃO--
BEGIN ATUVEROBJ('PROD_ENTR_REF','0.00.000'); END;
/